<?php
// RORboter - server window
// does the stuff

//main =========================================================================
require("gfx/head.include");

$date=date("d-m");
if (file_exists("logs/$date.log"))
  require("logs/$date.log");

$users = get_users();
foreach ($users as $user)
{
  $pass=get_pass($user);
  $action=get_action($user);
  $waittime=get_waittime($user);

  if(!$action)
    write_log("login <b>$user</b> : no action in stack. <b>paused</b>.<br>");
  else if ($waittime != 0)
  {
    dec_waittime($user);
    write_log("login <b>$user</b> : waittime != 0. <b>paused</b>.<br>");
  }
  else
  {
    $sid=get_sid($user,$pass);

    if (!$sid)
      write_log("<b>cant login</b><br>");
    else
      do_action($action, $sid, $user);
  }
}

write_log("session end. waiting ...<br><br>");
require("gfx/foot.include");


//do_action ====================================================================
function do_action($action, $sid, $user)
{
      $filename = "http://143.130.64.8:2000/index.php?action=$action&crorsid=$sid&crorloginname=$user";
      $content = implode ("", file ($filename));
      $content = explode(" ",$content);

      if ((in_array("NICHT", $content))||(in_array("nicht", $content)))
        write_log ("trying action <b>$action</b> ... <b>failed</b>. storing stack.<br>");
      else
      {
        write_log ("trying action <b>$action</b> ... <b>done</b>. rotating stack.<br>");
        rotate_stack($user);
        set_waittime($user, $action);
      }
}

//dec_waittime =================================================================
function dec_waittime($user)
{
  $sqlcon = connectdb();
  $sqlmemberquery = "SELECT waittime FROM rormember WHERE name ='$user'";
  $memberresult = mysql_query($sqlmemberquery, $sqlcon);
  while ($member = mysql_fetch_row($memberresult))
    $info = $member[0];

  if ($info > 0)
    $info --;
  else
    $info=0;

  $sqlcon = connectdb();
  $sqlquery = "UPDATE rormember SET waittime = '$info' WHERE name = '$user'";
  mysql_query($sqlquery, $sqlcon);
}

//set_waittime =================================================================
function set_waittime($user, $action)
{
  $sqlcon = connectdb();
  $sqlmemberquery = "SELECT waittime FROM roraction WHERE action ='$action'";
  $memberresult = mysql_query($sqlmemberquery, $sqlcon);
  while ($member = mysql_fetch_row($memberresult))
    $waittime = $member[0];

  $sqlcon = connectdb();
  $sqlquery = "UPDATE rormember SET waittime = '$waittime' WHERE name = '$user'";
  mysql_query($sqlquery, $sqlcon);
}

//rotate_stack =================================================================
function rotate_stack($user)
{
  $sqlcon = connectdb();
  $sqlmemberquery = "SELECT stack FROM rormember WHERE name ='$user'";
  $memberresult = mysql_query($sqlmemberquery, $sqlcon);
  while ($member = mysql_fetch_row($memberresult))
    $info = $member[0];

  $stack = explode(" ",$info);
  array_shift ($stack);

  $info = implode (" ",$stack);

  $sqlcon = connectdb();
  $sqlquery = "UPDATE rormember SET stack = '$info' WHERE name = '$user'";
  mysql_query($sqlquery, $sqlcon);
}

//get_waittime =================================================================
function get_waittime($user)
{
  $sqlcon = connectdb();
  $sqlmemberquery = "SELECT waittime FROM rormember WHERE name ='$user'";
  $memberresult = mysql_query($sqlmemberquery, $sqlcon);
  while ($member = mysql_fetch_row($memberresult))
    $info = $member[0];

  return $info;
}

//get_pass =====================================================================
function get_pass($user)
{
  $sqlcon = connectdb();
  $sqlmemberquery = "SELECT pass FROM rormember WHERE name ='$user'";
  $memberresult = mysql_query($sqlmemberquery, $sqlcon);
  while ($member = mysql_fetch_row($memberresult))
    $info = $member[0];

  return $info;
}

//get_action ===================================================================
function get_action($user)
{
  $sqlcon = connectdb();
  $sqlmemberquery = "SELECT stack FROM rormember WHERE name ='$user'";
  $memberresult = mysql_query($sqlmemberquery, $sqlcon);
  while ($member = mysql_fetch_row($memberresult))
    $info = $member[0];

  $stack = explode(" ",$info);
  return $stack[0];
}


//get_users ====================================================================
function get_users()
{
  $sqlcon = connectdb();

  $sqlquery = "SELECT * FROM rormember";
  $result = mysql_query($sqlquery, $sqlcon);

  $i=0;
  while ($werte = mysql_fetch_row($result))
  {
    $users[$i] = $werte[1];
    $i++;
  }
  return $users;
}

//get_sid ======================================================================
function get_sid($user, $pass)
{

  $fp = fsockopen ("143.130.64.8", 2000, $errno, $errstr, 30);

  if (!$fp)
  {
    write_log ("login <b>$user</b> ... <b>failed!</b> $errstr ($errno) - aborting");
    return NULL;
  }
  else
  {
    $method = "GET /index.php?action=login&fusername=$user&fpassword=$pass HTTP/1.0
               Host: 143.130.64.8\r\n\r\n
    ";

    fputs ($fp, $method);

    for($i=0; $i < 6; $i++)
      $rv= fgets ($fp,64);

    fclose ($fp);

    $rv = explode ("=", $rv);
    $rv[1]=trim($rv[1]);
    write_log("login <b>$user</b> ... <b>done</b>. session id: <b>$rv[1]</b>");
    return $rv[1];
  }
}

//write_log ====================================================================
function write_log($string)
{
  $date = date("H:i:s");
  $filedate=date("d-m");
  $string = "<b>$date</b> - $string<br>\r\n";
  echo $string;
  $fp = fopen ("logs/$filedate.log", "a");
  fwrite ($fp, $string);
  fclose ($fp);
}

//connectdb ====================================================================
function connectdb()
{
  include("gfx/sqlsettings.php");
  $sqlcon = mysql_connect ("$sqlserver", "$sqluser", "$sqlpass");
  if(!($sqlcon)) echo "Can't connect to db";

  mysql_select_db($sqldb);

  return $sqlcon;
}

?>